/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef DB_PARAM_H
#define DB_PARAM_H

#include <gvn/gvn-param.h>

#define DB_TYPE_PARAM				(db_param_get_type ())
#define DB_PARAM(self)				(G_TYPE_CHECK_INSTANCE_CAST (self, DB_TYPE_PARAM, DbParam))
#define DB_IS_PARAM(self)			(G_TYPE_CHECK_INSTANCE_TYPE (self, DB_TYPE_PARAM))
#define DB_PARAM_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST (klass, DB_TYPE_PARAM, DbParamClass))
#define DB_IS_PARAM_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE (klass, DB_TYPE_PARAM))
#define DB_PARAM_GET_CLASS(self)	(G_TYPE_INSTANCE_GET_CLASS (self, DB_TYPE_PARAM, DbParamClass))

typedef struct _DbParam DbParam;
typedef struct _DbParamClass DbParamClass;

#include "db-iterator.h"

struct _DbParam
{
	GObject parent;
	DbIterator * iterator;
	gint column_index;
	gchar * column_name;
	GValue * value;
	GvnParam * master;
	gboolean change_master;
};

struct _DbParamClass
{
	/* <private> */
	GObjectClass parent;
};

GType			db_param_get_type			();
GvnParam *		db_param_new				(const gchar * column_name);
GvnParam *		db_param_new_with_index		(guint column_index);
guint			db_param_get_column_index	(DbParam * self);
const gchar *	db_param_get_column_name	(DbParam * self);
void			db_param_set_iterator		(DbParam * self, DbIterator * iterator);

#endif