/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef DB_SIMPLE_ITERATOR_H
#define DB_SIMPLE_ITERATOR_H

#include "db-model.h"
#include "db-iterator.h"

#define DB_TYPE_SIMPLE_ITERATOR				(db_simple_iterator_get_type ())
#define DB_SIMPLE_ITERATOR(self)			(G_TYPE_CHECK_INSTANCE_CAST (self, DB_TYPE_SIMPLE_ITERATOR, DbSimpleIterator))
#define DB_IS_SIMPLE_ITERATOR(self)			(G_TYPE_CHECK_INSTANCE_TYPE (self, DB_TYPE_SIMPLE_ITERATOR))
#define DB_SIMPLE_ITERATOR_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST (klass, DB_TYPE_SIMPLE_ITERATOR, DbSimpleIteratorClass))
#define DB_IS_SIMPLE_ITERATOR_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE (klass, DB_TYPE_SIMPLE_ITERATOR))
#define DB_SIMPLE_ITERATOR_GET_CLASS(self)	(G_TYPE_INSTANCE_GET_CLASS (self, DB_TYPE_SIMPLE_ITERATOR, DbSimpleIteratorClass))

typedef struct _DbSimpleIterator DbSimpleIterator;
typedef struct _DbSimpleIteratorClass DbSimpleIteratorClass;

struct _DbSimpleIterator
{
	GObject parent;
	DbModel * model;
	GList * params;
	DbIteratorMode mode;
	DbIter * iter;
	gint row;
	gboolean remember_selection;
};

struct _DbSimpleIteratorClass
{
	/* <private> */
	GObjectClass parent;
};

GType					db_simple_iterator_get_type				();
DbIterator *			db_simple_iterator_new					(DbModel * model);

#endif
