/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GVN_TIME_H
#define GVN_TIME_H

#include <glib-object.h>

/**
 * GVN_TYPE_TIME:
 * 
 * The #GType for a boxed type holding a #GvnTime.
 **/
#define	GVN_TYPE_TIME	(gvn_time_get_type())

/**
 * GvnTime:
 * @hour: the hour, from 0 to 23
 * @min: the minutes, from 0 to 59
 * @sec: the seconds, from 0 to 59
 * @tz: the time-zone, from -12 to 12
 * 
 * Primary struct to handle the TIME type.
 **/
typedef struct _GvnTime GvnTime;

struct _GvnTime
{
	guint hour;
	guint min;
	guint sec;
	gint tz;
};

GType		gvn_time_get_type	();

GvnTime *	gvn_time_copy		(GvnTime * obj);
void		gvn_time_free		(GvnTime * obj);
GvnTime *	gvn_time_new		(guint h, guint m, guint s, gint tz);
gchar *		gvn_time_to_string	(GvnTime * obj, gboolean tz);

#endif
