/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_SHELVES_H
#define VN_SHELVES_H

#include <vn/vn.h>

#define VN_TYPE_SHELVES			(vn_shelves_get_type ())
#define VN_SHELVES(self)		(G_TYPE_CHECK_INSTANCE_CAST (self, VN_TYPE_SHELVES, VnShelves))
#define VN_IS_SHELVES(self)		(G_TYPE_CHECK_INSTANCE_TYPE (self, VN_TYPE_SHELVES))

typedef struct _VnShelves VnShelves;
typedef struct _VnShelvesClass VnShelvesClass;
typedef struct _VnShelf VnShelf;

struct _VnShelf
{
	gint width;
	gint height;
	gint max_height;
	gint tray_height;
	gint first_tray_elevation;
	gint tray_density;
	gint vspacing;
	gint hspacing;
};

struct _VnShelves
{
	VnForm parent;
	GtkPrintSettings * print_settings;
	GtkPrintOperationAction action;
	VnShelf shelf;

	// Cairo

	cairo_t * context_cr;
	cairo_t * cr;
	GList * pages;
	gint width;
	gint height;
	gdouble scale;
	gint page_x;
	gint page_y;
	gint shelf_x;
	gint shelf_y;
};

struct _VnShelvesClass
{
	VnFormClass parent;
};

GType	vn_shelves_get_type	();

#endif