/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef DB_SQLITE_H
#define DB_SQLITE_H

#include <db/db.h>
#include <sqlite3.h>

#define DB_TYPE_SQLITE				(db_sqlite_get_type ())
#define DB_SQLITE(self)				(G_TYPE_CHECK_INSTANCE_CAST ((self), DB_TYPE_SQLITE, DbSqlite))
#define DB_IS_SQLITE(self)			(G_TYPE_CHECK_INSTANCE_TYPE ((self), DB_TYPE_SQLITE))
#define DB_SQLITE_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), DB_TYPE_SQLITE, DbSqliteClass))
#define DB_IS_SQLITE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), DB_TYPE_SQLITE))
#define DB_SQLITE_GET_CLASS(self)	(G_TYPE_INSTANCE_GET_CLASS ((self), DB_TYPE_SQLITE, DbSqliteClass))

typedef struct _DbSqlite DbSqlite;
typedef struct _DbSqliteClass DbSqliteClass;

struct _DbSqlite
{
	DbPlugin parent;
	sqlite3 * sqlite;
};

struct _DbSqliteClass
{
	DbPluginClass parent;
};

GType		db_sqlite_get_type	();
DbConn *	db_sqlite_new		();

#endif