/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SQL_MULTI_STMT_H
#define SQL_MULTI_STMT_H

#include "sql-stmt.h"

#define SQL_TYPE_MULTI_STMT			(sql_multi_stmt_get_type ())
#define SQL_MULTI_STMT(obj)			(G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_MULTI_STMT, SqlMultiStmt))
#define SQL_IS_MULTI_STMT(obj)		(G_TYPE_CHECK_INSTANCE_TYPE (obj, SQL_TYPE_MULTI_STMT))

typedef struct _SqlMultiStmt SqlMultiStmt;
typedef struct _SqlMultiStmtClass SqlMultiStmtClass;

/**
 * SqlMultiStmt:
 * @stmt: (element-type Sql.Stmt): list of #SqlStmt
 **/
struct _SqlMultiStmt
{
	SqlStmt parent;
	SqlList * stmts;
};

struct _SqlMultiStmtClass
{
	/* <private> */
	SqlStmtClass parent;
};

GType			sql_multi_stmt_get_type	();
SqlObject *		sql_multi_stmt_new		();

#endif
