/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SQL_PARSER_H
#define SQL_PARSER_H

#include "sql-object.h"

#define SQL_PARSER_LOG_DOMAIN (g_quark_from_string ("SqlParser"))

/**
 * sql_parser_parse:
 * @sql: An string containing an SQL query.
 * @err: (out) (allow-none): a return location of a #GError or %NULL to ignore
 * 
 * Parses @sql and makes an #SqlObject from the query on it.
 * 
 * Return value: (transfer full): an #SqlObject.
 */
SqlObject * sql_parser_parse (const gchar * sql, GError ** err) G_GNUC_WARN_UNUSED_RESULT;

#endif