/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_GRID_H
#define VN_GRID_H

#include <db/db.h>
#include <gtk/gtk.h>
#include "vn-list-model.h"
#include "vn-column.h"

#define VN_TYPE_GRID			(vn_grid_get_type ())
#define VN_GRID(self)			(G_TYPE_CHECK_INSTANCE_CAST (self, VN_TYPE_GRID, VnGrid))
#define VN_IS_GRID(self)		(G_TYPE_CHECK_INSTANCE_TYPE (self, VN_TYPE_GRID))
#define VN_GRID_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST (klass, VN_TYPE_GRID, VnGridClass))
#define VN_IS_GRID_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE (klass, VN_TYPE_GRID))
#define VN_GRID_GET_CLASS(self)	(G_TYPE_INSTANCE_GET_CLASS (self, VN_TYPE_GRID, VnGridClass))

typedef struct _VnGrid VnGrid;
typedef struct _VnGridClass VnGridClass;

struct _VnGrid
{
	GtkTreeView parent;
	DbIter * iter;
	gint row;
	GList * params;
	DbModel * model;
	DbIteratorMode mode;
	gboolean remember_selection;
};

struct _VnGridClass
{
	/* <private> */
	GtkTreeViewClass parent;
};

GType		vn_grid_get_type		();
VnGrid *	vn_grid_new				(DbModel * model);

#endif