/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_LOGIN_H
#define VN_LOGIN_H

#include <gtk/gtk.h>
#include <db/db.h>

#define VN_LOGIN_LOG_DOMAIN		(g_quark_from_string ("VnLogin"))

#define VN_TYPE_LOGIN				(vn_login_get_type ())
#define VN_LOGIN(self)				(G_TYPE_CHECK_INSTANCE_CAST (self, VN_TYPE_LOGIN, VnLogin))
#define VN_IS_LOGIN(self)			(G_TYPE_CHECK_INSTANCE_TYPE (self, VN_TYPE_LOGIN))
#define VN_LOGIN_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST (klass, VN_TYPE_LOGIN, VnLoginClass))
#define VN_IS_LOGIN_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE (klass, VN_TYPE_LOGIN))
#define VN_LOGIN_GET_CLASS(self)	(G_TYPE_INSTANCE_GET_CLASS (self, VN_TYPE_LOGIN, VnLoginClass))

typedef struct _VnLogin VnLogin;
typedef struct _VnLoginClass VnLoginClass;

#include "vn-gui.h"

struct _VnLogin
{
	GObject parent;

	GtkBuilder * builder;
	GtkApplication * app;
	VnGui * gui;
	GtkWindow * window;
	GvnParam * user;
	GvnParam * pass;
	GvnParam * remember;
	GtkButton * connect;
	GtkWidget * stop;
	GtkButton * settings_button;
	DbConn * cfg_conn;
	DbIterator * login_data;
	DbIterator * last_conn;
	DbIterator * connections;
	
	GtkDialog * settings_dialog;
	GtkEntry * plugin;
	GtkEntry * host;
	GtkEntry * schema;
	GtkEntry * ssl_ca;
	GSettings * settings;
};

struct _VnLoginClass
{
	GObjectClass parent;
};

typedef enum
{
	 VN_LOGIN_ERR_BAD_SETTINGS = 1
}
VnLoginError;

GType		vn_login_get_type	();
VnLogin *	vn_login_new		(GtkApplication * application);

#endif