/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_SET_H
#define VN_SET_H

#include <db/db.h>
#include <gtk/gtk.h>

#define VN_TYPE_SET				(vn_set_get_type ())
#define VN_SET(obj)				(G_TYPE_CHECK_INSTANCE_CAST (obj, VN_TYPE_SET, VnSet))
#define VN_IS_SET(obj)			(G_TYPE_CHECK_INSTANCE_TYPE (obj, VN_TYPE_SET))
#define VN_SET_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST (klass, VN_TYPE_SET, VnSetClass))
#define VN_IS_SET_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE (klass, VN_TYPE_SET))
#define VN_SET_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS (obj, VN_TYPE_SET, VnSetClass))

typedef struct _VnSet VnSet;
typedef struct _VnSetClass VnSetClass;

/**
 * VnSet:
 * @objects: (element-type GObject):
 **/
struct _VnSet
{
	GObject parent;
	GList * objects;
	guint count;
};

struct _VnSetClass
{
	GObjectClass parent;
};

GType	vn_set_get_type	();

void			vn_set_add				(VnSet * obj
										,GObject * child);
void			vn_set_remove			(VnSet * obj
										,GObject * child);
const GList *	vn_set_get_objects		(VnSet * obj);											
GList *			vn_set_get_objects_list	(VnSet * obj);
guint			vn_set_get_length		(VnSet * obj);

#endif