/*
 * Copyright (C) 2012 - Juan Ferrer Toribio
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef VN_WINDOW_H
#define VN_WINDOW_H

#include <gtk/gtk.h>

#define VN_TYPE_WINDOW				(vn_window_get_type ())
#define VN_WINDOW(obj)				(G_TYPE_CHECK_INSTANCE_CAST (obj, VN_TYPE_WINDOW, VnWindow))
#define VN_IS_WINDOW(obj)			(G_TYPE_CHECK_INSTANCE_TYPE (obj, VN_TYPE_WINDOW))
#define VN_WINDOW_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST (klass, VN_TYPE_WINDOW, VnWindowClass))
#define VN_IS_WINDOW_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE (klass, VN_TYPE_WINDOW))
#define VN_WINDOW_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS (obj, VN_TYPE_WINDOW, VnWindowClass))

typedef struct _VnWindow VnWindow;
typedef struct _VnWindowClass VnWindowClass;

#include "vn-gui.h"

struct _VnWindow
{
	GObject parent;

	VnGui * gui;
	GtkWindow * widget;
	GtkDialog * about;
	GtkHeaderBar * header;
	GtkWidget * menu_button;
	GtkWidget * spinner;
	GtkNotebook * notebook;
	VnForm * active_form;
	gboolean maximized;
};

struct _VnWindowClass
{
	GObjectClass parent;
};

GType	vn_window_get_type	();

VnWindow *  vn_window_new (VnGui * gui, gint x, gint  y);
void		vn_window_set_show_tabs (VnWindow * window);
void		vn_window_add_form (VnWindow * window, const gchar * icon, const gchar * title, GtkWidget * form);

#endif
